# Template Coq-Project

## Beschreibung

Dies ist ein Template für ein Coq-Project, wie ich es in mehrerer meiner Projekte benutze.
Deswegen steht auch oben im Titel der Name dieses Vorlagen-Projektes.

Dieses [README](README.md) bietet dafür eine Struktur, die leicht für verschiedene Projekte wiederverwendbar ist.

## Aufbau

Folgende Dateien befinden sich im Repository:

- [Makefile](Makefile): Generisches Makefile, das mit mehreren Ordnern mit Coq-Dateien umgehen kann.
- [LICENSE](LICENSE): Informationen zum Licensing.

## Installation

Dieses Projekt benötigt keine detailreiche Installationsanleitung, man kann es einfach auf [Gitlab](https://gitlab.cs.fau.de/oc59yqul/template-coq) klonen:

```
git clone git@gitlab.cs.fau.de:oc59yqul/template-coq.git
```

## Usage

Um dieses Projekt als Vorlage zu benutzen, verwende ich folgenden Workflow:

1. Dieses Template als extra Remote adden:

```
git remote add template-coq git@gitlab.cs.fau.de:oc59yqul/template-readme.git
git fetch template-coq
```

2. Danach mittels `git merge comoproj-v*` gewünschte Version mergen. 

Achtung: Tags wie z.B. `comoproj-v2.3.1` beziehen sich zumindest bezüglich der Gitlab-CI/CD immer auf die `latest`-Coq-Version.
Sollte man eine spezielle Version hierfür benötigen, stehen für einzelne Coq-Versionen bereits spezielle Versionen bereit, z.B. `comoproj-v2.3.1-coqc-v8.16.1`.

Aktuell werden für folgende Coq-Versionen konkrete Releases erstellt:

- 8.16.1
- 8.18.0

## Contributing

Ich freue mich über konkrete Verbesserungsvorschläge. Diese können

- völlig unkonkret über Issues oder
- konkret über Patches oder Merge Requests

eingebracht werden. Bei Bedarf füge ich einzelne Personen auch gerne als Developer dem Repo hinzu, falls dies den Workflow erleichtert.

## Kontakt

Ich bin u.A. per [E-Mail](ole.elliger@fau.de) erreichbar.
